//cmi5
var API = null;

(function( $ ) {
	function Scorm() {
		var launchUrl;
		var cmi5, lrs;
		var agent, activity;
		var data, progress;
		var session;
		var auth;
		var url;
		var ownLMS;
		var obj
		var endpoint;
		var badgeId;
		var maxQuestionCount;
		var rawScore;
		var expPoints;
        var cmi5Failed;
        var cmi5Statements;
        var cmi5States;
        var funScore;
	}

	Scorm.prototype = {
		constract: Scorm,

		initAPI:function() {
			obj = this;

			launchUrl = document.location.href;

			fetchUrl	    = plugin.getQueryVar('fetch', launchUrl);
            clientShortname = plugin.getQueryVar('clientShortname', fetchUrl);
			userId 		    = plugin.getQueryVar('userId', fetchUrl);
			courseId 	    = plugin.getQueryVar('courseId', fetchUrl);
            activityId      = plugin.getQueryVar('activityId', launchUrl);
            actor           = plugin.getQueryVar('actor', launchUrl);
			registration    = plugin.getQueryVar('registration', launchUrl);
			hasMessageEvent = plugin.getQueryVar('hasMessageEvent', launchUrl);

			rawScore = 0;
			expPoints = 0;

            cmi5Failed = false;
            cmi5Statements = [];
            cmi5States = [];

			try {
			    cmi5 = new Cmi5(launchUrl);

			    lrs = cmi5.getLRS();
			    activity =  cmi5.getActivity(),
            	agent =  cmi5.getActor(),

			    API = true;
			}
			catch (ex) {
			    console.log("Failed to setup Cmi5 object: " + ex);

                cmi5Failed = true;

			    API = false;

			    game.processLMSData();

			    return;
			}

			if(hasMessageEvent) {
				// Webkit only exists in mobile
				setTimeout(() => {
					this.postMessage({
						'callback': 'xSetCourseStarted',
						'data': 1
					});
				}, 1000 );
			} else {
				localStorage.setItem('questStarted', 1);
			}

			cmi5.start(
			    function (err) {
			        if (err !== null) {
			            console.log("Failed to start AU session: ", err);

                        // Fail to start cmi5 means no statement cannot be prepared
                        cmi5Failed = true;

                        // Saves statement and cmi5 data to local storage
                        var unsyncStmt = {
                            "statement" : "initialized"
                        };

                        obj.saveStatementToLS(unsyncStmt);

                        obj.loadData();

			            return;
			        }

			        console.log("cmi5 started");

			        obj.loadData();

                    obj.initializeCourse();
			    }
			);
		},

        setFunScore:function(score){
            funScore = score;
        },

		setState:function(key, valueObj) {
        	return lrs.saveState(key, valueObj, {
            	activity: activity,
            	agent: agent,
            	contentType: "application/json",
                callback: function () {
					if(hasMessageEvent) {
						obj.postMessage({
							'callback': 'xSetCurrentSlide',
							'data': valueObj.currentSlide
						});
					} else {
						localStorage.setItem('currentSlide', valueObj.currentSlide);
					}
		        }
            });
		},

		getState:function(key) {
			return lrs.retrieveState(key, {
            	activity: activity,
            	agent: agent
            });

		},

		setProgress:function(progress) {
            // Save state to local storage if cmi5 failed to initialize
            if(cmi5Failed) {
                localStorage.setItem("state-progress", JSON.stringify(progress));
            } else {
				var response = this.setState("progress", progress);

                if(response.status != 204) {
                    localStorage.setItem("state-progress", JSON.stringify(progress));
                }
            }
		},

		setStatus:function(status) {
            if(status == "completed") {

				if(hasMessageEvent) {
					obj.postMessage({
						'callback': 'xSetCourseCompleted',
						'data': {
								'earnedBadge': questCompletedBadgeId,
								'questCompleted': 1
							}
					});
				}

                // Save statement to local storage if cmi5 failed to initialize
                var unsyncStmt = {
                        "statement" : "completed",
                        "data" : {
                            "userId" : userId,
                            "courseId" : courseId,
                            "xp" : xpPoints,
                            "questCompletedBadgeId" : questCompletedBadgeId,
                            "funScore" : funScore
                        }
                    };

                if(cmi5Failed) {

                    obj.saveStatementToLS(unsyncStmt);

                } else {
                    var completedStmt = cmi5.prepareStatement(
                        "http://adlnet.gov/expapi/verbs/completed"
                    );

                    completedStmt.target = new TinCan.Activity({
                        "id" : activityId,
                        "definition": {
                            "extensions" : {
                                "http://growthengineering.co.uk/xapi/cmi5/object/extensions/xp" : xpPoints,
                                "http://growthengineering.co.uk/xapi/cmi5/object/extensions/badgeId" : questCompletedBadgeId,
                                "http://growthengineering.co.uk/xapi/cmi5/object/extensions/funScore" : funScore
                            }
                        }

                    });

                    cmi5.sendStatement(
                        completedStmt,
                        function (err, result, st) {
                            if (err !== null) {

                                obj.saveStatementToLS(unsyncStmt);

                                return;
                            }

                            // TODO: handle success
							if(!hasMessageEvent) {
								localStorage.setItem('earnedBadge', questCompletedBadgeId);
								localStorage.setItem('earnedXpPoints', xpPoints);
								localStorage.setItem('questCompleted', 1);
							}
                        }
                    );
                }

			    this.passFailedStatement();

			}


		},

		setData:function(data) {

            if(data == null) {
                data = {};
            }

			// Include userId and courseid to add in quest_points leaderboard
			data.userId = userId;
			data.courseId = courseId;

            // Save state to local storage if cmi5 failed to initialize
            if(cmi5Failed) {
                localStorage.setItem("state-data", JSON.stringify(data));
            } else {
                var response = this.setState("data", data);

                if(response.status != 204) {
                    localStorage.setItem("state-data", JSON.stringify(data));
                }
            }
		},

		setScore:function(score) {

			rawScore = score;

		},

		setInteractions:function(interactions) {

			// Not needed in cmi5. Interactions are sent using answered statement
            // and bookmarking is saved in data state document

		},

		getProgress:function() {

            var progress = null;

            if ( Object(data).currentSlide >= 0 ) {
                progress = data.currentSlide;
            }

			return progress;

		},

		getData:function() {

			return data;

		},

		getVersion:function() {
			return "cmi5";
		},

		loadData:function() {

			var dataStateResult = this.getState("data");

            data =  null;

			if (dataStateResult.err === null && dataStateResult.state !== null && dataStateResult.state.contents !== "") {
                if(!jQuery.isEmptyObject(dataStateResult.state.contents)) {
				    data = dataStateResult.state.contents;
                }
			}

			game.processLMSData();
		},

        initializeCourse:function() {
            // Save statement to local storage if cmi5 failed to initialize

            var unsyncStmt = {
                    "statement" : "initialize"
                }

            if(cmi5Failed) {

                obj.saveStatementToLS(unsyncStmt);

            } else {
                cmi5.initialize( function (err) {
                    if (err !== null) {
                        console.log("Failed to initialize AU session: ", err);

                        obj.saveStatementToLS(unsyncStmt);

                        localStorage.setItem('unsyncedData', scorm.getAllUnsyncData());

                        return;
                    }

                    console.log("AU initialize");
                });
            }
        },

		terminateCourse:function() {
            // Save statement to local storage if cmi5 failed to initialize

            var unsyncStmt = {
                    "statement" : "terminated"
                }

            if(cmi5Failed) {

                obj.saveStatementToLS(unsyncStmt);

				obj.closeBrowser();

            } else {
                cmi5.terminate( function (err) {

                    if (err !== null) {
                        console.log("Failed to terminate AU session: ", err);

                        obj.saveStatementToLS(unsyncStmt);

						if(!hasMessageEvent) {
							localStorage.setItem('unsyncedData', scorm.getAllUnsyncData());
						}

						obj.closeBrowser();

                        return;
                    }
                    console.log("AU Terminated");

					obj.closeBrowser();
                });
            }
		},

		closeBrowser:function() {
			if(hasMessageEvent) {
				this.postMessage({
					'callback': 'xTerminateCourse',
					'data': plugin.getQueryVar('appAction', appExitHTMLPath)
				});
			} else {
				window.location.href = appExitHTMLPath;
			}
		},

		earnedBadge:function(badgeId, badgeTitle, badgeDescription, badgeUrl, badgeType) {
            // Save statement to local storage if cmi5 failed to initialize
            var unsyncStmt = {
                    "statement" : "earned",
                    "data" : {
                        "userId" : userId,
                        "badgeId" : badgeId,
                        "badgeTitle" : badgeTitle,
                        "badgeDescription" : badgeDescription,
                        "activityId" : activityId,
                        "badgeType": badgeType
                    }
                }

            if(cmi5Failed) {

                obj.saveStatementToLS(unsyncStmt);

            } else {
                var earnedStmt = cmi5.prepareStatement(
                    "http://id.tincanapi.com/verb/earned"
                );

                earnedStmt.verb = new TinCan.Verb({
                    "id" : "http://id.tincanapi.com/verb/earned",
                    "display" : {
                        "en" : "earned"
                    }
                });

                earnedStmt.target = new TinCan.Activity({
                    "id" : activityId + "/badges/" + badgeId,
                    "definition": {
                        "type": "http://activitystrea.ms/schema/1.0/badge",
                        "name": {
                          "en-US": badgeTitle
                        },
                        "description": {
                          "en-US": badgeDescription
                        },
                        "extensions" : {
                            "http://growthengineering.co.uk/xapi/cmi5/object/extensions/badgeId" : badgeId,
                            "http://growthengineering.co.uk/xapi/cmi5/object/extensions/auid" : activityId,
                            "http://growthengineering.co.uk/xapi/cmi5/object/extensions/badgeType": badgeType
                        }
                    }
                });

                cmi5.sendStatement(
                    earnedStmt,
                    function (err, result, st) {
                        if (err !== null) {

                            obj.saveStatementToLS(unsyncStmt);

                            return;
                        }

                        // TODO: handle success
                    }
                );
            }

		},

		passFailedStatement:function() {

          	if (maxQuestionCount !== 0) { // check if there is one or more questions

				var scaled = rawScore/maxQuestionCount;

				var scoreObj = {
					'min': 0,
					'max': maxQuestionCount,
					'scaled': scaled,
					'raw': rawScore
				};

				if (scaled >= masterScore) {
                    // Save statement to local storage if cmi5 failed to initialize

                    var unsyncStmt = {
                            "statement" : "passed",
                            "data" : {
                                "min" : scoreObj.min,
                                "max" : scoreObj.max,
                                "scaled" : scoreObj.scaled,
                                'raw': scoreObj.raw
                            }
                        }

                    if(cmi5Failed) {

                        obj.saveStatementToLS(unsyncStmt);

                    } else {
                        cmi5.passed(scoreObj, function (err) {
                            if (err !== null) {

                                obj.saveStatementToLS(unsyncStmt);

                                return;
                            }
                            console.log("AU passed");
                        });
                    }

				} else {
                    // Save statement to local storage if cmi5 failed to initialize
                    var unsyncStmt = {
                            "statement" : "failed",
                            "data" : {
                                "min" : scoreObj.min,
                                "max" : scoreObj.max,
                                "scaled" : scoreObj.scaled,
                                'raw': scoreObj.raw
                            }
                        };
                    var myJsonString = JSON.stringify(unsyncStmt);
                    console.log(myJsonString);
                    if(cmi5Failed) {

                        obj.saveStatementToLS(unsyncStmt);

                    } else {
                        cmi5.failed(scoreObj, function (err) {
                            if (err !== null) {

                                obj.saveStatementToLS(unsyncStmt);

                                return;
                            }
                            console.log("AU failed");
                        });
                    }

				}

			}
		},

		sendAnsweredStatement:function(isCorrect, response, question, choices, questionId) {

           var success = (isCorrect == 'true') ? true : false;

            // Save statement to local storage if cmi5 failed to initialize
            var unsyncStmt = {
                "statement" : "answered",
                "data" : {
                    "success" : success,
                    "response" : String(response),
                    "question": question,
                    "choices" : choices,
                    "clientShortname" : clientShortname,
                    "questionId" : questionId,
                    "activityId" : activityId,
					"type" : "choice"
                }
            };

            if(cmi5Failed) {
                obj.saveStatementToLS(unsyncStmt);

            } else {
                var answeredStmt = cmi5.prepareStatement(
                    "http://adlnet.gov/expapi/verbs/answered"
                );

                answeredStmt.result = new TinCan.Result({
                    "success" : success,
                    "response" : String(response)
                });

                choice = [];

                $.each(choices, function(i, v){
                    choice.push({
                        'id' : v.choiceId ? v.choiceId : "null",
                        'description': {
                            "en-US": v.choices
                        }
                    })
                });

               answeredStmt.target = new TinCan.Activity({

                    "id" : activityId+"/interactions/"+questionId,
                    "definition": {
                        "description": {
                            "en-US": question
                        },
                        "extensions" : {
                            "http://growthengineering.co.uk/xapi/cmi5/object/extensions/questionId" : questionId,
                            "http://growthengineering.co.uk/xapi/cmi5/object/extensions/auid" : activityId
                        },
                        "type": "http://adlnet.gov/expapi/activities/cmi.interaction",
                        "interactionType": "choice",
                        "choices": choice

                    }

                });

                cmi5.sendStatement(
                    answeredStmt,
                    function (err, result, st) {
                        if (err !== null) {

                            obj.saveStatementToLS(unsyncStmt);

                            return;
                        }

                        // TODO: handle success
                    }
                );
            }

		},

		sendAnsweredMatchingStatement:function(isCorrect, response, question, sources, targets, correctPattern, questionId) {

		   var success = (isCorrect == 'true') ? true : false;

		    // Save statement to local storage if cmi5 failed to initialize
		    var unsyncStmt = {
		        "statement" : "answered",
		        "data" : {
		            "success" : success,
		            "response" : String(response),
		            "question": question,
		            "sources": sources,
		            "targets": targets,
		            "correctPattern": correctPattern,
		            "clientShortname" : clientShortname,
		            "questionId" : questionId,
		            "activityId" : activityId,
		            "type" : "matching"
		        }
		    };

		    if(cmi5Failed) {
		        obj.saveStatementToLS(unsyncStmt);

		    } else {
		        var answeredStmt = cmi5.prepareStatement(
		            "http://adlnet.gov/expapi/verbs/answered"
		        );

		        answeredStmt.result = new TinCan.Result({
		            "success" : success,
		            "response" : String(response)
		        });

		        source = [];
		        $.each(sources, function(i, value){
		            source.push({
		                'id' : value,
		                'description': {
		                    "en-US": value
		                }
		            })
		        });

		        target = [];
		        $.each(targets, function(i, value){
		            target.push({
		                'id' : value,
		                'description': {
		                    "en-US": value
		                }
		            })
		        });

		       answeredStmt.target = new TinCan.Activity({

		            "id" : activityId+"/interactions/"+questionId,
		            "definition": {
		                "description": {
		                    "en-US": question
		                },
		                "extensions" : {
		                    "http://growthengineering.co.uk/xapi/cmi5/object/extensions/questionId" : questionId,
		                    "http://growthengineering.co.uk/xapi/cmi5/object/extensions/auid" : activityId
		                },
		                "type": "http://adlnet.gov/expapi/activities/cmi.interaction",
		                "interactionType": "matching",
		                "correctResponsesPattern": [correctPattern],
		                "source": source,
		                "target": target
		            }

		        });

		        cmi5.sendStatement(
		            answeredStmt,
		            function (err, result, st) {
		                if (err !== null) {

		                    obj.saveStatementToLS(unsyncStmt);

		                    return;
		                }

		                // TODO: handle success
		            }
		        );
		    }

		},

        // Save statement to LocalStorage and sync later
        saveStatementToLS:function(stmtObject) {
			localStorage.setItem("cmi5-failed", 1);
            cmi5Statements.push(stmtObject);
			localStorage.setItem("statements", JSON.stringify(cmi5Statements));
            this.saveCmi5QueryVars();

			if(hasMessageEvent) {
				this.postMessage({
					'callback': 'xSetUnsyncedData',
					'data': scorm.getAllUnsyncData()
				});
			}
        },

        // Save query vars
        saveCmi5QueryVars:function() {
            var cmi5Data = {
                "userId"       : userId,
                "courseId"     : courseId
            }

            localStorage.setItem("cmi5-data", JSON.stringify(cmi5Data));
        },

        // Return all unsync data
        getAllUnsyncData:function() {
			if(localStorage.getItem("cmi5-failed")) {
                var unsyncData = {
                    "cmi5Data" : JSON.parse(localStorage.getItem("cmi5-data")),
                    "statements" : JSON.parse(localStorage.getItem("statements")),
                    "states" : [
                        {
                            "state": "data" ,
                            "data": JSON.parse(localStorage.getItem("state-data"))
                        }
                    ],
                }

                console.log(JSON.stringify(unsyncData));
                return JSON.stringify(unsyncData);
            }

            return null;
        },

        // Load all unsync data back to local storage
        loadAllUnsyncData:function(unsyncData) {
			localStorage.setItem("cmi5-failed", 1);
            localStorage.setItem("cmi5-data", JSON.stringify(unsyncData.cmi5Data));
            localStorage.setItem("statements", JSON.stringify(unsyncData.statements));
            cmi5Statements = unsyncData.statements;

            $.each(unsyncData.states, function(index, state) {
                 localStorage.setItem("state-" + state.state, JSON.stringify(state.data));
            });
        },

		setScoreMin: function(min) {},
		setScoreMax: function(max) {
			maxQuestionCount = max;
		},
		getLearnerID:function() {
			return agent.account.name;
		},
		getLearnerName:function() {
			return agent.name;
		},

		// Post a message from template to cordova
		postMessage: function(data) {
			if(typeof(webkit) === "undefined") return;

            webkit.messageHandlers.cordova_iab.postMessage(JSON.stringify(data));
		},

	}

	window.Scorm = Scorm;

}( jQuery ));
